#version 330

uniform float exposure;
uniform float decay;
uniform float density;
uniform float weight;
uniform vec3 lightPositionOnScreen;
uniform sampler2D firstPass;
const int NUM_SAMPLES = 100 ;

uniform bool sunInFrustrum;


in vec2 fragmentUV;

layout (location = 0) out vec4 fragColor;

void main()
{	
		vec2 lightPos = vec2(lightPositionOnScreen.x, lightPositionOnScreen.y);
	   //if (lightPositionOnScreen.y > 1.0f || lightPositionOnScreen.x > 1.0f) {
	   //     lightPos.x = 0.5f;
		//	lightPos.y = 0.5f;
		//}

		//vec2 deltaTextCoord = vec2(fragmentUV - lightPositionOnScreen.xy );
		vec2 deltaTextCoord = vec2(fragmentUV - lightPos.xy );
		vec2 textCoo = fragmentUV;
    	deltaTextCoord *= 1.0 /  float(NUM_SAMPLES) * density;
    	float illuminationDecay = 1.0;
	
		vec4 originalColor = texture2D(firstPass, fragmentUV);

		
	   //if (lightPositionOnScreen.y > 1.0f || lightPositionOnScreen.x > 1.0f ||  !sunInFrustrum) {
		//	fragColor = texture2D(firstPass, fragmentUV);
	   //} else {
	  
	  vec4 effectColor = vec4(0.0f, 0.0f, 0.0f, 1.0f);
    	for(int i=0; i < NUM_SAMPLES ; i++)
        {
                 textCoo -= deltaTextCoord;

                 vec4 sample = texture2D(firstPass, textCoo );
				

                 sample *= illuminationDecay * weight;

                 effectColor += sample;

                 illuminationDecay *= decay;
         }
		 effectColor *= exposure;
		 
		 
		 //fragColor = effectColor;

		 if (sunInFrustrum) {
		 fragColor = effectColor * 0.55f;
		 //} else if (lightPositionOnScreen.y > 1.0f){
		 // fragColor = mix(originalColor, effectColor, 1/lightPositionOnScreen.y);
		 //} 
		 }else {
		 fragColor = originalColor * 1.5f;
		 }

		//if (lightPositionOnScreen.x > 1.0f || lightPositionOnScreen.y > 1.0f) {
		//	fragColor = texture2D(firstPass, fragmentUV);
		//}


		 //vec4 effectColor = fragColor;


		 //vec4 originalColor = texture2D(firstPass,  fragmentUV);

		 //if (effectColor.x > originalColor.x && effectColor.y > originalColor.y && effectColor.z > originalColor.z) {
		//	fragColor = originalColor + effectColor;
		 //}
		 //else {
		//	fragColor = originalColor;
		 //}

		 
}