#version 330

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;

out vec3 worldNormal;
out vec3 worldPos;
out vec2 fragmentUV;
out vec4 viewSpace;
out vec4 projCoords;
out vec4 fragPosLightSpace;

uniform mat4 model;
uniform mat4 view; // for fog
uniform mat4 view_project;
uniform mat4 projectorMatrix;
uniform mat4 lightSpaceMatrix;

void main()
{
	fragmentUV = uv; // they don't have to be transformed

	worldNormal = (model * vec4(normal,0)).xyz; // would be more complicated for non-uniform scaling
	gl_Position = view_project * model * vec4(position, 1);

	viewSpace = view * model * vec4(position,1);
	worldPos = mat3(model) * position;
	//worldPos = model * mat4(position,1);

	projCoords = projectorMatrix * vec4(worldPos,1);

	fragPosLightSpace = lightSpaceMatrix * vec4(worldPos, 1.0);
}
